Index: skin/easyedit.js
===================================================================
--- skin/easyedit.js	(revision 0)
+++ skin/easyedit.js	(revision 75)
@@ -0,0 +1,434 @@
+﻿// $Id:$
+// Copyright (C) 2006 hiroppi
+// License: GPL2
+
+// 簡単編集
+function EasyEditor()
+{
+	var editor = this;
+
+	// 画面の作成
+	this.popup = document.createElement('div');
+	this.popup.className = 'easy_editor';
+	this.popup.style.display = 'none';
+	document.body.appendChild(this.popup);
+
+	this.editor = document.createElement('textarea');
+	this.editor.className = 'easy_editor';
+	this.popup.appendChild(this.editor);
+
+	this.buttons = document.createElement('div');
+	this.buttons.className = 'easy_editor_buttons';
+	this.popup.appendChild(this.buttons);
+
+	this.cancel = document.createElement('div');
+	this.cancel.className = 'easy_editor_button';
+	this.cancel.innerHTML = 'Cancel';
+	this.buttons.appendChild(this.cancel);
+
+	var dummy = document.createElement('div');
+	dummy.style.cssFloat = 'right';
+	dummy.style.styleFloat = 'right';
+	dummy.innerHTML = '&nbsp;';
+	this.buttons.appendChild(dummy);
+
+	this.ok = document.createElement('div');
+	this.ok.className = 'easy_editor_button';
+	this.ok.innerHTML = 'OK';
+	this.buttons.appendChild(this.ok);
+
+	var dummy = document.createElement('div');
+	dummy.style.clear = 'both';
+	this.buttons.appendChild(dummy);
+
+	this.bottom = document.createElement('div');
+	this.bottom.className = 'easy_editor_resize_bar';
+	this.bottom.style.display = 'none';
+	// IEはbackground-colorがtransparentだとonmouseoverに飛びづらいようだ
+	this.bottom.style.filter = 'alpha(opacity=0)';
+	this.bottom.style.opacity = 0.0;
+	document.body.appendChild(this.bottom);
+
+	this.cancel.onmouseover = function() { this.className = 'easy_editor_button_highlight' };
+	this.cancel.onmouseout = function() { this.className = 'easy_editor_button' };
+	this.cancel.onselectstart = function() { return false; };
+	this.cancel.onmousedown = function() { return false; };
+	this.cancel.onclick = function() {
+		var postdata = editor.editor.value.replace(/\r\n/g, '\n');
+		if (editor.section.text.replace(/[\n]*$/g, '') != postdata.replace(/[\n]*$/g, '')) {
+			if (!confirm('変更内容を破棄しますか？')) {
+				return true;
+			}
+		}
+		editor.close();
+		return true;
+	};
+
+	this.ok.onmouseover = function() { this.className = 'easy_editor_button_highlight' };
+	this.ok.onmouseout = function() { this.className = 'easy_editor_button' };
+	this.ok.onselectstart = function() { return false; };
+	this.ok.onmousedown = function() { return false; };
+	this.ok.onclick = function() {
+		editor.close();
+		var y = editor.getScrollY();
+		var section = editor.section;
+		var url = 'index.php?cmd=edit&post=on&page=' + section.page + '&id=' + section.id;
+		var post = '';
+
+		post += "encode_hint=ぷ";
+		post += '&msg=' + encodeURIComponent(editor.editor.value);
+		post += '&digest=' + encodeURIComponent(section.md5);
+		post += '&original=' + encodeURIComponent(editor.original);
+		post += '&write=ページの更新';
+		editor.connect(url, 'POST', post, function(req) {
+			document.body.innerHTML = req.responseText;
+			EasyEditor.prototype.factory();
+			scrollTo(0, y);
+		});
+		return true;
+	};
+
+	// リサイズ
+	this.bottom.onmouseover = function(e) {
+		e = e || window.event;
+		this.style.cursor = 's-resize';
+	}
+
+	this.bottom.onmousedown = function(e) {
+		var bottom = this;
+
+		// 選択の禁止
+		document.onselectstart = function() { return false; }
+		document.onmousedown = function() { return false; }
+		document.onclick = function() { return true; }
+
+		// 移動中
+		document.onmousemove = function(e) {
+			e = e || window.event;
+			var y = e.clientY + editor.getScrollY() - bottom.offsetHeight / 2;
+			height = y - editor.popup.offsetTop - editor.buttons.offsetHeight;
+			if (editor.HEIGHT_MIN <= height && height <= editor.HEIGHT_MAX) {
+				bottom.style.top = y + 'px';
+				height = y - editor.popup.offsetTop;
+				editor.popup.style.height = height + 'px';
+				if (document.addEventListener) {
+					// FirefoxはoffsetHeightを渡す
+					height = editor.popup.offsetHeight;
+				}
+				editor.adjustEditor(0, height);
+			}
+		}
+
+		// リサイズの終了
+		document.onmouseup = function(e) {
+			document.onselectstart = null;
+			document.onmousedown = null;
+			document.onclick = null;
+			document.onmousemove = null;
+			document.onmouseup = null;
+		}
+	}
+}
+
+EasyEditor.prototype.HEIGHT_MIN = 100;
+EasyEditor.prototype.HEIGHT_MAX = 300;
+
+// スタイルシートの属性値を求める
+EasyEditor.prototype.getStyle = function(obj, propie, prop) {
+	if (obj.currentStyle) {
+		return obj.currentStyle[propie];
+	}
+	else if (window.getComputedStyle) {
+		var style = window.getComputedStyle(obj, '');
+		return style.getPropertyValue(prop);
+	}
+	return '';
+}
+
+// スタイルシートの属性値をピクセル値で求める
+EasyEditor.prototype.getStylePixel = function(obj, propie, prop) {
+	var style = this.getStyle(obj, propie, prop);
+	if (style && style.match(/(\d+)/)) {
+		return parseInt(RegExp.$1);
+	}
+	return 0;
+}
+
+// 縦方向のスクロール位置
+EasyEditor.prototype.getScrollY = function() {
+	if (window.scrollY) {
+		return window.scrollY;
+	}
+	else if (document.documentElement && document.documentElement.scrollTop) {
+		return document.documentElement.scrollTop;
+	}
+	else if (document.body && document.body.scrollTop) {
+		return document.body.scrollTop;
+	}
+	return 0;
+}
+
+// エディタの作成、クッキーの読み込みおよび設定
+EasyEditor.prototype.factory = function() {
+	var expires = new Date();
+	expires.setTime(expires.getTime() + 30*24*60*60*1000);
+
+	var abort = false;
+	var cookies = document.cookie.split('; ');
+	for (var i in cookies) {
+		var key = cookies[i].split('=')[0];
+		var value = unescape(cookies[i].split('=')[1]);
+		var path = value;
+		var locationpath = location.pathname;
+
+		// 値からパスを分離する
+		value = value.replace(/,.*$/, '');
+		path = path.replace(/^[^,]*,/, '');
+		locationpath = locationpath.replace(/[^\/]*$/, '');
+		if (path != locationpath) {
+			continue;
+		}
+
+		if (key == 'plugin_easyedit_available') {
+			document.cookie = "plugin_easyedit_available=" + value + ',' + locationpath
+				"; expires=" + expires.toGMTString();
+			if (value != 'checked') {
+				abort = true;
+			}
+		}
+		if (key == 'plugin_easyedit_height_min') {
+			EasyEditor.prototype.HEIGHT_MIN = value;
+			document.cookie = "plugin_easyedit_height_min=" + value + ',' + locationpath
+				"; expires=" + expires.toGMTString();
+		}
+		if (key == 'plugin_easyedit_height_max') {
+			EasyEditor.prototype.HEIGHT_MAX = value;
+			document.cookie = "plugin_easyedit_height_max=" + value + ',' + locationpath
+				"; expires=" + expires.toGMTString();
+		}
+	}
+
+	if (abort) {
+		return;
+	}
+	var editor = new EasyEditor();
+	editor.searchAnchors();
+}
+
+// pukiwikiとの通信
+EasyEditor.prototype.connect = function(url, mode, data, func) {
+	var req;
+
+	mode = mode || 'GET';
+	data = data || '';
+	if (window.XMLHttpRequest) {
+		req = new window.XMLHttpRequest();
+	}
+	else if(window.ActiveXObject) {
+		req = new ActiveXObject("Microsoft.XMLHTTP");
+	}
+	else {
+		return;
+	}
+
+	var changed = function() {
+		if (req.readyState == 4) {
+			if (req.status == 200) {
+				func && func(req);
+			}
+			else {
+				alert(req.status + ' ' + req.statusText);
+			}
+		}
+	}
+
+	req.abort();
+	req.open(mode, url, true);
+	req.onreadystatechange = changed;
+	req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
+	req.setRequestHeader("If-Modified-Since", "Thu, 01 Jun 1970 00:00:00 GMT");
+	req.setRequestHeader("Pragma", "no-cache");
+	req.setRequestHeader("Cache-Control", "no-cache");
+	req.send(data);
+}
+
+// 編集画面の表示
+EasyEditor.prototype.open = function(section) {
+	if (this.popup.style.display != 'none') {
+		if (section.text.replace(/[\n]*$/g, '') != this.editor.value.replace(/[\n]*$/g, '')) {
+			if (!confirm('変更内容を破棄しますか？')) {
+				return;
+			}
+		}
+	}
+	this.popup.style.display = 'block';
+	this.bottom.style.display = 'block';
+	this.section = section;
+
+	// 位置の計算
+	var top = section.div.offsetTop;
+	var left = section.div.offsetLeft;
+	var current = section.div;
+	while (current) {
+		if (current.tagName == 'TD' || current.tagName == 'TABLE') {
+			top += current.offsetTop;
+			left += current.offsetLeft;
+		}
+		current = current.parentNode;
+	}
+
+	this.popup.style.top = top + 'px';
+	this.popup.style.left = left + 'px';
+
+	// 大きさの計算
+	var height = section.div.offsetHeight;
+	height = Math.max(height, this.HEIGHT_MIN);
+	height = Math.min(height, this.HEIGHT_MAX);
+	// IEはとりあえず'0px'を設定しないとサイズが変わらない
+	this.editor.style.height = '0px';
+	this.popup.style.height = height + 'px';
+
+	var width = section.div.offsetWidth;
+	var styles = {
+	borderLeftWidth: 'border-left-width',
+	borderRightWidth: 'border-right-width',
+	paddingLeftWidth: 'padding-left',
+	paddingRightWidth: 'padding-right'
+	};
+	for (var i in styles) {
+		width -= this.getStylePixel(this.popup, i, styles[i]);
+	}
+	this.popup.style.width = width + 'px';
+
+	this.adjustEditor();
+	this.editor.value = section.text.replace(/[\n]*$/g, '') + '\n';
+
+	// 掴める部分の移動
+	var styles = {
+	borderLeftWidth: 'border-left-width',
+	paddingLeftWidth: 'padding-left'
+	};
+	for (var i in styles) {
+		left += this.getStylePixel(this.popup, i, styles[i]);
+		left += this.getStylePixel(this.bottom, i, styles[i]);
+	}
+	this.bottom.style.top = top + this.popup.offsetHeight - this.bottom.offsetHeight / 2 + 'px';
+	this.bottom.style.left = left + 'px';
+	this.bottom.style.width = this.editor.style.width;
+}
+
+// 編集画面を閉じる
+EasyEditor.prototype.close = function() {
+	this.popup.style.display = 'none';
+	this.bottom.style.display = 'none';
+}
+
+// エディタのサイズをポップアップに合わせる
+EasyEditor.prototype.adjustEditor = function(width, height) {
+	width = width || this.popup.offsetWidth;
+	height = height || this.popup.offsetHeight;
+	var diff;
+
+	var styles = {
+	borderTopWidth: 'border-top-width',
+	borderBottomWidth: 'border-bottom-width',
+	paddingTopWidth: 'padding-top',
+	paddingBottomWidth: 'padding-bottom'
+	};
+	diff = 0;
+	for (var i in styles) {
+		diff += this.getStylePixel(this.popup, i, styles[i]);
+		diff += this.getStylePixel(this.buttons, i, styles[i]);
+		diff += this.getStylePixel(this.ok, i, styles[i]);
+	}
+	this.editor.style.height = height - this.buttons.offsetHeight - diff + 'px';
+
+	var styles = {
+	borderLeftWidth: 'border-left-width',
+	borderRightWidth: 'border-right-width',
+	paddingLeftWidth: 'padding-left',
+	paddingRightWidth: 'padding-right'
+	};
+	diff = 0;
+	for (var i in styles) {
+		diff += this.getStylePixel(this.popup, i, styles[i]);
+		diff += this.getStylePixel(this.editor, i, styles[i]);
+	}
+	this.editor.style.width = width - diff + 'px';
+}
+
+// 編集用アンカーを探す
+EasyEditor.prototype.searchAnchors = function() {
+	var editor = this;
+	var ary = document.getElementsByTagName('a');
+	var anchors = new Array();
+
+	// 編集用アンカーだけを取得
+	for (var i in ary) {
+		if (ary[i] && ary[i].className == 'anchor_super' && !ary[i].id) {
+			anchors.push(ary[i]);
+		}
+	}
+
+	// アンカーの収集と書き換え、ページとセクションの収集
+	var pages = new Object();
+	for (var i in anchors) {
+		if (anchors[i].href.match(/&page=([^&]*)&id=([a-z](?:[a-f0-9]{7}|[a-f0-9]{32}))$/)) {
+			var section = new Object();
+			section.text = '';
+			section.page = RegExp.$1;
+			section.id = RegExp.$2;
+			section.div = anchors[i].parentNode.parentNode;
+			section.anchor = anchors[i];
+
+			if (!pages[section.page]) {
+				pages[section.page] = new Object();
+			}
+			anchors[i].href = 'javascript:void(0)';
+			if (pages[section.page][section.id]) {
+				anchors[i].innerHTML = '';
+				continue;
+			}
+			pages[section.page][section.id] = section;
+			anchors[i].section = section;
+		}
+	}
+
+	// セクションごとのテキストを取得し、セクションに持たせる
+	for (var page in pages) {
+		this.connect('index.php?cmd=easyedit&page=' + page, 'GET', '', function(req) {
+			var xml = req.responseXML;
+			editor.original = xml.getElementsByTagName('original')[0].firstChild.nodeValue;
+
+			var elements = xml.getElementsByTagName('section');
+			var sections = new Object();
+			for (var i=0; i<elements.length; ++i) {
+				var id = elements[i].getAttribute('id');
+				if (!sections[id]) {
+					sections[id] = elements[i];
+				}
+			}
+			for (var id in pages[page]) {
+				if (!sections[id]) {
+					continue;
+				}
+				//pages[page][id].text = sections[id].firstChild.nodeValue;
+				// Firefoxはテキストノードの最大文字数が4096文字らしい
+				pages[page][id].text = '';
+				for (var i=0; i<sections[id].childNodes.length; ++i) {
+					pages[page][id].text += sections[id].childNodes[i].nodeValue;
+				}
+				pages[page][id].md5 = sections[id].getAttribute('md5');
+				pages[page][id].anchor.section = pages[page][id];
+				pages[page][id].anchor.onclick = function() { editor.open(this.section) };
+			}
+		});
+	}
+}
+
+if (window.addEventListener) {
+	window.addEventListener('load', EasyEditor.prototype.factory, true);
+}
+else if (window.attachEvent) {
+	window.attachEvent('onload', EasyEditor.prototype.factory);
+}

Property changes on: skin/easyedit.js
___________________________________________________________________
Name: svn:keywords
   + Id

Index: skin/pukiwiki.skin.php
===================================================================
--- skin/pukiwiki.skin.php	(revision 16)
+++ skin/pukiwiki.skin.php	(revision 75)
@@ -78,9 +78,11 @@
  <link rel="SHORTCUT ICON" href="<?php echo $image['favicon'] ?>" />
  <link rel="stylesheet" type="text/css" media="screen" href="skin/pukiwiki.css.php?charset=<?php echo $css_charset ?>" charset="<?php echo $css_charset ?>" />
  <link rel="stylesheet" type="text/css" media="print"  href="skin/pukiwiki.css.php?charset=<?php echo $css_charset ?>&amp;media=print" charset="<?php echo $css_charset ?>" />
+ <link rel="stylesheet" type="text/css" media="all"    href="skin/easyedit.css?charset=<?php echo $css_charset ?>" charset="<?php echo $css_charset ?>" />
  <link rel="alternate" type="application/rss+xml" title="RSS" href="<?php echo $link['rss'] ?>" /><?php // RSS auto-discovery ?>
 
 <?php if (PKWK_ALLOW_JAVASCRIPT && $trackback_javascript) { ?> <script type="text/javascript" src="skin/trackback.js"></script><?php } ?>
+ <script type="text/javascript" src="skin/easyedit.js"></script>
 
 <?php echo $head_tag ?>
 </head>
Index: skin/easyedit.css
===================================================================
--- skin/easyedit.css	(revision 0)
+++ skin/easyedit.css	(revision 75)
@@ -0,0 +1,44 @@
+/*
+ * $Id$
+ * Copyright (C) 2006 hiroppi
+ * License: GPL2
+*/
+
+div.easy_editor {
+	background-color: #EEF5FF;
+	border: #888899 1px solid;
+	padding: 2px;
+	position: absolute;
+}
+
+textarea.easy_editor {
+	font-size: 90%;
+}
+
+div.easy_editor_buttons {
+	padding-top: 2px;
+}
+
+div.easy_editor_button,
+div.easy_editor_button_highlight {
+	background-color: #DDEEFF;
+	float: right;
+	text-align: center;
+	width: 80px;
+	font-size: 80%;
+	border: #888899 1px solid;
+	padding: 2px;
+	cursor: default;
+}
+
+div.easy_editor_button_highlight {
+	background-color: #F5F8FF;
+}
+
+div.easy_editor_resize_bar {
+	border: black 1px solid;
+	background-color: white;
+	height: 8px;
+	position: absolute;
+	overflow: hidden;
+}

Property changes on: skin/easyedit.css
___________________________________________________________________
Name: svn:keywords
   + Id

Index: plugin/easyedit.inc.php
===================================================================
--- plugin/easyedit.inc.php	(revision 0)
+++ plugin/easyedit.inc.php	(revision 75)
@@ -0,0 +1,111 @@
+<?php
+// $Id:$
+// Copyright (C) 2006 hiroppi
+// License: GPL2
+
+define('PLUGIN_EASYEDIT_TITLE', 'Easy Edit');
+define('PLUGIN_EASYEDIT_COOKIE_LIFETIME', 30*24*60*60);
+
+define('PLUGIN_EASYEDIT_DEFAULT_HEIGHT_MIN', 100);
+define('PLUGIN_EASYEDIT_DEFAULT_HEIGHT_MAX', 300);
+
+function plugin_easyedit_cookie($key, $value)
+{
+	// ѥͤղä
+	$value .= ',' . preg_replace('/[^\/]*$/', '', $_SERVER['PHP_SELF'], 1);
+	// ꤷLIFE TIMEϤJavaScriptǾ񤭤
+	setcookie('plugin_easyedit_' . $key, $value, time() + PLUGIN_EASYEDIT_COOKIE_LIFETIME);
+}
+
+function plugin_easyedit_convert()
+{
+	return '<a href="index.php?cmd=easyedit&settings=on">' . PLUGIN_EASYEDIT_TITLE . '</a>';
+}
+
+function plugin_easyedit_action()
+{
+	global $vars;
+
+	$text = '';
+
+	if (isset($vars['settings'])) {
+		$vars['msg'] = PLUGIN_EASYEDIT_TITLE;
+		
+		$referer = '';
+		if (isset($_SERVER["HTTP_REFERER"])) $referer = $_SERVER["HTTP_REFERER"];
+		if (isset($vars['referer'])) $referer = $vars['referer'];
+		$vars['available'] = isset($vars['available']) ? 'checked' : 'off';
+		if (isset($vars['entry'])) {
+			plugin_easyedit_cookie('available', $vars['available']);
+			if (preg_match('/\d+/', $vars['height_min'], $matches)) {
+				plugin_easyedit_cookie('height_min', $matches[0]);
+			}
+			if (preg_match('/\d+/', $vars['height_max'], $matches)) {
+				plugin_easyedit_cookie('height_max', $matches[0]);
+			}
+			$text .= 'cookieꤷޤ';
+		}
+		else {
+			if (!isset($_COOKIE['plugin_easyedit_available']) ||
+					$_COOKIE['plugin_easyedit_available'] == 'checked') {
+				$vars['available'] = 'checked';
+			}
+			$vars['height_min'] = PLUGIN_EASYEDIT_DEFAULT_HEIGHT_MIN;
+			if (!empty($_COOKIE['plugin_easyedit_height_min'])) {
+				$vars['height_min'] = $_COOKIE['plugin_easyedit_height_min'];
+				$vars['height_min'] = preg_replace('/,.*$/', '', $vars['height_min']);
+			}
+			$vars['height_max'] = PLUGIN_EASYEDIT_DEFAULT_HEIGHT_MAX;
+			if (!empty($_COOKIE['plugin_easyedit_height_max'])) {
+				$vars['height_max'] = $_COOKIE['plugin_easyedit_height_max'];
+				$vars['height_max'] = preg_replace('/,.*$/', '', $vars['height_max']);
+			}
+			$text .= 'cookie˰ʲιܤϿޤ';
+		}
+
+		$text .= <<<EOT
+<form method="post" action="{$_SERVER['PHP_SELF']}?cmd=easyedit&settings=on">
+<br />
+
+<input type="checkbox" name="available" value="checked" {$vars['available']}>
+Easy EditȤ<br />
+ԽɥκǾι⤵
+<input type="text" name="height_min" value="{$vars['height_min']}">
+<br />
+Խɥκι⤵
+<input type="text" name="height_max" value="{$vars['height_max']}">
+<br />
+
+<br />
+<input type="hidden" name="referer" value="$referer">
+<input type="submit" name="entry" value="¸">
+<input type="button" name="return" value="" onclick="document.location='$referer'">
+</form>
+EOT;
+
+		return array('msg'=>PLUGIN_EASYEDIT_TITLE, 'body'=>$text);
+	}
+
+	$lines = get_source($vars['page']);
+	$body = get_parsed_body($lines);
+	header('Content-type: application/xml');
+
+	print '<?xml version="1.0" encoding="UTF-8"?>' . "\n";
+	$text = "<body>\n";
+	$text .= '<page>' . htmlspecialchars($vars['page']) . "</page>\n";
+	$text .= '<original>' . htmlspecialchars($body->getText()) . "</original>\n";
+	$sections = $body->getSections();
+	for ($i=0; $i<count($sections); ++$i) {
+		$text .= '<section id="' . htmlspecialchars($sections[$i]->anchorid) . "\" " . 
+			"md5=\"" . md5($sections[$i]->getText()) . "\">";
+		$text .= htmlspecialchars($sections[$i]->getText());
+		$text .= "</section>\n";
+	}
+	$text .= "</body>\n";
+	if (CONTENT_CHARSET != 'UTF-8') {
+		$text = mb_convert_encoding($text, 'UTF-8', CONTENT_CHARSET);
+	}
+	print $text;
+	exit;
+}
+?>

Property changes on: plugin/easyedit.inc.php
___________________________________________________________________
Name: svn:keywords
   + Id

